<?php
class Memori extends Module
{
	// Параметры модуля
	var $name = 'Memori'; // Имя сервиса, отображаемое пользователю
	var $id = 'Memori'; // Все тот же Module_ID
	var $url = 'http://memori.ru/'; // URL сервиса. Настоятельно рекомендую указывать правильный :-)
	var $icon = 'memori.png'; // Имя иконки. Должна лежать в одной папке с файлом модуля.
	var $notice = ''; // Дополнительная информация, которую мы желаем сообщить пользователям
	var $email_confirm = true; // Требуется ли подтверждение по email
	var $core_version = 3; // Версия ядра, на которую рассчитан модуль, необходимо для проверки совместимости. Нынешняя, как не трудно догадаться - 3
	var $encoding = 'cp1251'; // Кодировка сайта.
	
	/**
	 * Функция, ответственная за загрузку капчи.
	 * Если ввод капчи не требуется, возвращает null. В противном случае возвращает массив данных, 
	 * которые понадобятся при отправке формы, в т. ч. имя временного файла с кукисами, различные токены и т. п.
	 * Обязательно в массиве должен быть элемент image_file, чтобы RegSubmitter мог отобразить капчу пользователю для ввода.
	 */
	function GetForm()
	{
		// Запрашиваем страницу регистрации.
		$page = $this->Get('http://memori.ru/registration/');
		// Извлекаем токен
		preg_match('#<input type="hidden" name="token" value="([0-9a-z]+)" />#is', $page, $matches);
		
		// Ноу-хау: допываем картинку из рекапчи
		$js = $this->Get('http://api.recaptcha.net/challenge?k=6LfV6wgAAAAAAF327mU7j7lzG6s-p1SolxPA2Wx2');
		preg_match("#challenge : '([^']+)'#", $js, $key);
		// Собственно скачиваем картинку
		$image = $this->Get("http://api.recaptcha.net/image?c=$key[1]");
		
		// Генерируем имена временных файлов для хранения кукисов и картинки. Параметр - префикс имени файла.
		$cookies_file = $this->TempFile('cookie');
		$image_file = $this->TempFile('image');
		
		$this->SaveCookies($cookies_file); // Сохраняем кукисы
		file_put_contents($image_file, $image); // Сохраняем картинку
		
		// Возвращаем данные, которые нам понадобятся потом.
		return array(
			'image_file'	=> $image_file, // Картинку капчи. ОБЯЗАТЕЛЬНО!
			'cookies_file'	=> $cookies_file, // Файл с кукисами
			'key'			=> $matches[1], // Токен формы, добытый в начале
			'recaptcha'		=> $key[1], // Токен рекапчи
		);
	}
	
	/**
	 * Эта функция занимается собственно произведением регистрации.
	 * Параметры:
	 * - $account массив из элеменитов login, password, email. Назначение, думаю, очевидно :)
	 * - $data тот самый массив, который мы вернули из функции GetForm()
	 * - $captcha текст, написанный по мнению пользователя на капче.
	 * Функция возвращает null в случае успеха или массив сообщений об ошибках, если они возникли.
	 */
	function SubmitReg($account, $data, $captcha)
	{
		// Собираем запрос
		$post_data = array(
			'login'			=> $account['login'], // Логин
			'email'			=> $account['email'], // Емейл
			'password'		=> $account['password'], // Пароль
			'password_confirm'	=> $account['password'], // И снова пароль
			'recaptcha_response_field'	=> $captcha, // Текст с картинки
			'recaptcha_challenge_field'	=> $data['recaptcha'], // Токен рекапчи
			'token'			=> $data['key'], // Токен формы
			'inviter'		=> '', // Просто пустое поле. Видимо, для какой-то реферральной системы
		);
		
		// Загружаем сохраненные кукисы с прошлого раза
		$this->LoadCookies($data['cookies_file']);
		// Отправляем запрос. Первый параметр - куда, второй - параметры запроса, 
		// третий (опциональный, по умолчанию - false) - надо ли преобразовывать страницу из кодировки сайта в родную для RS (utf-8)
		// Очевидно, что для веб-страниц его надо ставить true, а дял картинок - false. Аналогичный параметр есть и у метода $this->Get()
		$html_data = $this->Post("http://memori.ru/register/", $post_data, true);
		
		// Проверяем успешность регистрации
		if(strstr($html_data, 'На указанный Вами электронный адрес'))
		{
			return null;
		}
		else
		{
			// Если не прошло, добываем ошибки.
			preg_match_all('#<p class="error">([^<]+)</p>#mu', $html_data, $matches);
			return $matches[1];
		}
	}
	
	/**
	 * Функция подтверждения по почте.
	 * Параметр $account содержит те же данные о логине, пароле и email-e, что и в случае с методом SubmitReg.
	 * возвращает null в случае успеха или массив с сообщениями об ошибках в ином случае.
	 */
	function Confirm($account)
	{
		// Ищем письмо по отправителю. Кроме того, в теле письма должен упоминаться домен из поля $this->url
		$mail = $this->findMail('no-reply@memori.ru');

		// Загружаем тело сообщения
		$text = $this->getMailBody($mail['msg_id']);
		
		// Извлекаем ссылку подгверждения
		preg_match('#http://memori.ru/regconfirm/[0-9]+/[0-9a-z]+/#i', $text, $url);

		// Отправляем запрос
		$html_data = $this->Get($url[0], true);

		// Проверяем успешность
		if(strstr($html_data, '/logout/'))
		{
			return null;
		}
		else
		{
			// Если что не так - ругаемся.
			return array('Произошла ошибка активации или аккаунт уже был ранее подтвержден');
		}
	}
}
// Alles :-)
?>